
'                                           EXAMPLE03
'
'                               USING TWO COGS (TWO PROCESSORS)                               
'*************************************************************************************************
'IMPORTANT: This example requires an understanding of examples 01 and 02.
'*************************************************************************************************
'WHAT'S NEW IN THIS EXAMPLE:
'
'   COG: This is the term used by the designers (Parallax, Inc.) of the Propeller. It refers 
'        to a processor in the Propeller chip. This chip has eight Cogs, or processors.
'*************************************************************************************************
'
'DIFFICULTY LEVEL: Easy
'
'PURPOSE:
'  -- The purpose of this example is to demonstrate the use of two Cogs (two processors)
'     running separate procedures in PARALLEL.
'
'ADDITIONAL INFORMATION: 
'  -- The two procedures in this example have the same function as in Example 02; that is, the
'     procedures turn on and off an LED every second. However, in this example the procedures
'     run in PARALLEL because each is run by a different processor; consequently, the
'     two LEDs will blink in sync. In Example 02, the two procedures were run sequentially
'     using one processor.
'
'Submitted by Dave Scanlan, Feb 28, 2006           
'File: Example03_UsingTwoCogs.spin
'*************************************************************************************************
'CORRECT OUTPUT: The LEDs at A16 and A17 should blink on and off every second. Both should
'                blink on and off at the same time. 
'*************************************************************************************************
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
' 
  High = 1
  Low  = 0
'
VAR
  long  stack0[20]                   'Sets up a stack space for a Cog(processor)
  long  stack1[20]                   'Sets up a stack space for a second Cog(processor)
                                     'long stack0[20]: Allocates 20 longs for the stack.
                                     'long stack1[20]: Allocates 20 longs for the stack.     
PUB Start
  cognew(BlinkingLED_A16, @stack0)   'Starts a Cog, calls BlinkingLED_A16, the Cog uses @stack0
  cognew(BlinkingLED_A17, @stack1)   'Starts a Cog, calls BlinkingLED_A17, the Cog uses @stack1
'
PRI BlinkingLED_A16 | Pin              
  Pin := 16
  DirA[Pin] := %1
'                 
  Repeat 5
    OutA[Pin] := High                                                     
    WaitCnt(40_000_000 + Cnt)          
    OutA[Pin] := Low                   
    WaitCnt(40_000_000 + Cnt)          
'
PRI BlinkingLED_A17 | Pin              
  Pin := 17
  DirA[Pin] := %1
'                 
  Repeat 5
    OutA[Pin] := High                                                     
    WaitCnt(40_000_000 + Cnt)          
    OutA[Pin] := Low                   
    WaitCnt(40_000_000 + Cnt)

'INDENTION IS IMPORTANT IN SPIN CODE