
'                                FEWER COMMENTS (EASIER TO READ)
'
'                                           EXAMPLE07
'
'                           CHECKS FOR A HIGH ON PIN A1; HAS VIDEO OUTPUT                     
'**************************************************************************************
'IMPORTANT: This example requires an understanding of examples 01 and 03.
'**************************************************************************************
'DIFFICULTY LEVEL: Very Easy
'**************************************************************************************
'CORRECT OUTPUT: If Pin A1 is High the following happens:
'                  (1) The message "INPUT AT PIN A1" is repeatedly displayed on the
'                      monitor.
'                  (2) The monitor's foreground and background become white-on-blue
'                  (3) The LED at A16 is turned on
'
'                If Pin A1 is Low the following happens:
'                  (1) The message "NO INPUT" is repeatedly displayed on the monitor
'                  (2) The monitor's foreground and background become white-on-red
'                  (3) The LED at A16 is turned off
'
'NOTE: USE A 10K PULL-DOWN RESISTER TO KEEP PIN A1 FROM FLOATING: Place a 10K resistor
'      between Pin A1 and Vss.
'
'Submitted by Dave Scanlan, March 8, 2006          
'File: Example07_FewerComments.spin
'**************************************************************************************
'
CON
  _clkmode = xtal1 + pll16x       
  _xinfreq = 5_000_000
  NewLine = 13
  High = 1
  Low = 0
  Out = %1
  In = %0
'
VAR
'  
OBJ
  VideoDisplay: "TV_Terminal"               
'
PUB Start                                   
  VideoDisplay.Start
  CheckForInput
'  
PRI CheckForInput
'
  DirA[1]  := In                            
  DirA[16] := Out                           
'
  Repeat                                    
' 
    If InA[1] == High
      SetScreenToWhiteOnDarkBlue
      VideoDisplay.str(string("INPUT AT PIN A1"))
      OutA[16] := High
    Else
      SetScreenToWhiteOnRed
      VideoDisplay.str(string("NO INPUT"))
      OutA[16] := Low
'     
    VideoDisplay.out(NewLine)
'
PRI SetScreenToWhiteOnDarkBlue              
  VideoDisplay.Out(3)                       
  VideoDisplay.Out(5)
'
PRI SetScreenToWhiteOnRed                   
  VideoDisplay.Out(3)                       
  VideoDisplay.Out(7)                         
'
'INDENTION IS IMPORTANT IN SPIN.