
'********************************************************************************* 
'                            EXPLANATION OF TERMS IN EXAMPLES
'********************************************************************************* 
'  PROCEDURE
'     The term procedure is an umbrella term that can refer to a function procedure
'     (function), a sub-procedure, or an event procedure. (Microsoft's definition)
'
'     (1) FUNCTION PROCEDURE (or FUNCTION)
'         When a function is called it performs some procedure and always
'         returns a value when the procedure ends.
'     (2) SUB-PROCEDURE
'         When a sub-procedure is called, it too performs some procedure, but it
'         does not return a value when the procedure ends.
'
'PUB and PRI are both procedures.  Since they both return values, they are a
'special type of procedure, a procedure called a "function procedure" or just
'a function. 
' 
'In early examples in this series of examples, PUB and PRI were called
'procedures.  I did this to keep the reader from looking for a return value
'which is necessary with a function.  There was a return value but it
'could not be seen by the reader. When you get the documentation, you
'can dive deeper into this subject. In example 10 and 11, there was  
'an explicit return value.
'*********************************************************************************
'*********************************************************************************
'In the future, PUB and PRI will be referred to as functions.
'*********************************************************************************
'*********************************************************************************
'NOTE: No attempt was made to cover all the variations of the above terms. 
'      Only Microsoft's thinking was given. Event procedures were not covered.
'*********************************************************************************
'
'
'
'
'                                     EXAMPLE 11
'
'     A SECOND WAY TO CODE A FUNCTION: FIND THE LARGEST OF TWO VALUES (Ver. 2)               
'*********************************************************************************  
'IMPORTANT: This example may require an understanding of examples 04,05,06 and 10
'*********************************************************************************
'WHAT'S NEW IN THIS EXAMPLE:
'
'     FUNCTION W/O USING THE "RESULT" KEYWORD": In this example, we will return 
'                                               a result without using the
'                                               keyword "Result".  We will make up
'                                               a word we want to use.  
'*********************************************************************************  
'DIFFICULTY LEVEL: Intermediate
'
'PURPOSE: This code demonstrates how to code a function.  This function will return
'         the largest of two values. The function will not use the keyword "Result."
'
'Submitted by Dave Scanlan, March 16, 2006         
'File: Example11_FunctionFindLargestVer2.spin
'*********************************************************************************
'CORRECT OUTPUT:  The largest value (10) will be displayed on the video monitor.
'*********************************************************************************
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
' 
VAR
'No global variables used.
'
OBJ
  VideoDisplay: "TV_Terminal"            
'
PUB Start | X, Y, LargestValue        'X, Y, and LargestValue are Local variables.
  VideoDisplay.Start
  SetScreenToWhiteOnDarkBlue
'
  X := 5
  Y := 10
' 
  LargestValue := FindTheLargest(X,Y) 'Calls the function and assigns the
'                                      result to "LargestValue."
  VideoDisplay.Dec(LargestValue)
'
PRI FindTheLargest (X,Y) : Largest     'Largest returns the result. Note the ":".
  If X > Y
    Largest := X
  Else
    Largest := Y
'
PRI SetScreenToWhiteOnDarkBlue                  
  VideoDisplay.Out(3)                           
  VideoDisplay.Out(5)
'
'
'ADDITIONAL INFORMATION ON HOW THIS FUNCTION WORKS:
'  Rather than use the reserved word "Result" we can choose the word we
'  want. In the function declaration below "Largest" was used to return
'  the function's value.
'  PRI FindTheLargest (X,Y) : Largest
'
'  IMPORTANT: You must use the colon ":" before Largest.
'             We could have used any valid identifier.
'             Largest holds the function's return value.
'
'IN ORDER TO KEEP THINGS SIMPLE, I HAVE ELIMINATED SOME OF THE DETAILS.  REFER
'TO THE DOCUMENTATION WHEN YOU GET IT.